package ac.essex.ca.util;

import javax.swing.*;
import java.awt.*;

/**
 * <p>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 08-Aug-2006
 * @version 1.0
 */
public class GridPanel extends JPanel {

    protected int Y = 1;
    protected int X = 1;
    protected int data[][];

    protected Color gridColor = Color.LIGHT_GRAY;

    public GridPanel(int rows, int cols) {
        this.Y = rows;
        this.X = cols;
        clearData();
    }

    public void clearData() {
        data = new int[X][Y];
    }

    public int[][] getData() {
        return data;
    }

    public void setCell(int x, int y, int value) {
        data[x][y] = value;
    }

    public void setData(int[][] data) {
        this.data = data;
    }

    public void paint(Graphics g) {

        super.paint(g);

        g.setColor(gridColor);

        double gridWidth = getWidth() / (double) X;
        double gridHeight = getHeight() / (double) Y;

        // draw the Y grid
        for (int i = 1; i < X; i++) {

            int xPosition = (int) (gridWidth * i);

            // draw a vertical line
            g.drawLine(xPosition, 0, xPosition, getHeight());

        }

        // draw the X grid
        for (int i = 1; i < X; i++) {

            int yPosition = (int) (gridHeight * i);

            // draw a horizontal line
            g.drawLine(0, yPosition, getWidth(), yPosition);

        }

        // now draw the data

        for (int y = 0; y < X; y++) {
            for (int x = 0; x < X; x++) {
                if (data[x][y] != 0) {
                    // draw a box in this grid
                    int xPosition = (int) (gridWidth * x) + 1;
                    int yPosition = (int) (gridHeight * y) + 1;

                    g.setColor(Color.BLUE);
                    g.fillRect(xPosition, yPosition, ((int) gridWidth) - 1, ((int) gridHeight) - 1);
                }
            }
        }

        // draw a black box aroung the whole thing

        g.setColor(Color.GRAY);
        g.drawRect(0,0,getWidth() - 1, getHeight() - 1);



    }


}
